<!----------------------------------------------------------------------------------------------------------------------
  -- Response Form
  --------------------------------------------------------------------------------------------------------------------->

<template>
    <div id="response-form">
        <BCard no-body class="h-100">
            <BTabs v-model="tabIndex" card class="h-100">
                <template #tabs-end>
                    <li v-if="response" class="ms-auto d-flex justify-content-end">
                        <div class="mt-1">
                            <h4 class="d-inline-block mb-0" style="margin-top: -7px">
                                <BBadge
                                    v-if="response"
                                    class="me-1"
                                    :variant=" response.status === 'succeeded' ? 'success' : 'danger' "
                                >
                                    {{ response.status === 'succeeded' ? 'Succeeded' : 'Failed' }}
                                </BBadge>
                                <BBadge class="me-1">
                                    {{ byteSize }}kB
                                </BBadge>
                                <BBadge class="me-1" :variant="durationVariant">
                                    {{ duration.toFixed(2) }}ms
                                </BBadge>
                            </h4>
                            <BButton
                                class="ms-1"
                                size="sm"
                                style="margin-top: -0.4rem"
                                :title="`Copy ${ tabIndex === 2 ? 'Response' : 'Payload' }`"
                                @click="copyResponse()"
                            >
                                <Fa icon="copy" />
                            </BButton>
                        </div>
                    </li>
                </template>
                <BTab title="Payload" no-body>
                    <BPlaceholderWrapper :loading="responseLoading">
                        <template #loading>
                            <div class="p-3">
                                <BPlaceholder width="80%" />
                                <BPlaceholder width="55%" />
                                <BPlaceholder width="70%" />
                                <BPlaceholder width="65%" />
                                <BPlaceholder width="85%" />
                                <BPlaceholder width="60%" />
                                <BPlaceholder width="55%" />
                                <BPlaceholder width="55%" />
                                <BPlaceholder width="70%" />
                            </div>
                        </template>

                        <Codemirror
                            v-if="response"
                            ref="payloadCM"
                            v-model="formattedPayload"
                            :extensions="cmExtensions"
                            :tab-size="4"
                        />
                        <div v-else class="card-body">
                            <h6 class="text-center mt-2">
                                No response to display. Please make a request.
                            </h6>
                        </div>
                    </BPlaceholderWrapper>
                </BTab>
                <BTab :disabled="!hasMessages" no-body>
                    <template #title>
                        Messages
                        <BBadge v-if="errorMessagesCount" class="ml-1" variant="danger">
                            {{ errorMessagesCount }}
                        </BBadge>
                        <BBadge v-if="warningMessagesCount" class="ml-1" variant="warning">
                            {{ warningMessagesCount }}
                        </BBadge>
                        <BBadge v-if="infoMessagesCount" class="ml-1" variant="info">
                            {{ infoMessagesCount }}
                        </BBadge>
                        <BBadge v-if="debugMessagesCount" class="ml-1" variant="dark">
                            {{ debugMessagesCount }}
                        </BBadge>
                    </template>
                    <div id="messagesList" class="m-2">
                        <BAlert
                            v-for="(message, messageIndex) in messages"
                            :key="`response-message-${messageIndex}`"
                            :model-value="true"
                            :variant="getMessageAlertVariant(message.severity)"
                            class="mb-2"
                        >
                            <div class="messagesHeader">
                                <Fa :icon="getMessageAlertIcon(message.severity)" class="mr-1" />
                                {{ message.message }}
                            </div>
                            <div class="ml-4">
                                <span class="messagesLabel">Severity:</span>
                                {{ message.severity }}
                            </div>
                            <div class="ml-4">
                                <span class="messagesLabel">Type:</span>
                                {{ message.type }}
                            </div>
                            <div class="ml-4">
                                <span class="messagesLabel">Code:</span>
                                {{ message.code }}
                            </div>
                            <div v-if="message.details" class="ml-4 mt-1 d-flex">
                                <span class="messagesLabel">Details:</span>
                                <pre class="messagesDetails">{{ JSON.stringify(message.details, null, 2) }}</pre>
                            </div>
                            <div v-if="message.stack" class="ml-4 mt-1 d-flex">
                                <span class="messagesLabel">Stack:</span>
                                <pre class="messagesDetails">{{ message.stack }}</pre>
                            </div>
                        </BAlert>
                    </div>
                </BTab>
                <BTab title="Full Response" no-body>
                    <BPlaceholderWrapper :loading="responseLoading">
                        <template #loading>
                            <div class="p-3">
                                <BPlaceholder width="80%" />
                                <BPlaceholder width="55%" />
                                <BPlaceholder width="70%" />
                                <BPlaceholder width="65%" />
                                <BPlaceholder width="85%" />
                                <BPlaceholder width="60%" />
                                <BPlaceholder width="55%" />
                                <BPlaceholder width="55%" />
                                <BPlaceholder width="70%" />
                            </div>
                        </template>

                        <Codemirror
                            v-if="response"
                            ref="responseCM"
                            v-model="formattedResponse"
                            :extensions="cmExtensions"
                            :tab-size="4"
                        />
                        <div v-else class="card-body">
                            <h6 class="text-center mt-2">
                                No response to display. Please make a request.
                            </h6>
                        </div>
                    </BPlaceholderWrapper>
                </BTab>
            </BTabs>
        </BCard>
    </div>
</template>

<!--------------------------------------------------------------------------------------------------------------------->

<style lang="scss">
    @media screen and (min-width: 1172px) and (min-height: 470px) {
        #response-form {
            .cm-editor {
                height: calc(100vh - 166px) !important;
            }

            #messagesList {
                max-height: calc(100vh - 198px) !important;
                overflow-y: auto;
            }
        }
    }

    #response-form {
        .messagesHeader {
            font-weight: 500;
        }

        .messagesLabel {
            display: inline-block;
            width: 75px;
            font-weight: 700;
            font-size: .8em;
        }

        .messagesDetails {
            margin-bottom: 0;
        }
    }
</style>

<!--------------------------------------------------------------------------------------------------------------------->

<script lang="ts" setup>
    import { computed, ref, watch } from 'vue';
    import { useObservable } from '../../lib/composables/rxjs.js';

    import { json5 } from 'codemirror-json5';
    import { EditorState } from '@codemirror/state';
    import { oneDark } from '@codemirror/theme-one-dark';

    // Components
    import { Codemirror } from 'vue-codemirror';

    // Managers
    import clipboardMan from '../../lib/managers/clipboard.js';
    import requestMan from '../../lib/managers/request.js';

    // Resource Access
    import colorMode from '../../lib/resource-access/colorMode';

    //------------------------------------------------------------------------------------------------------------------
    // Refs
    //------------------------------------------------------------------------------------------------------------------

    const tabIndex = ref(0);

    const baseCMExtensions = [
        EditorState.readOnly.of(true),
        json5(),
    ];
    const bsTheme = useObservable(colorMode.bsTheme$);

    const payloadCM = ref<typeof Codemirror>(null);
    const responseCM = ref<typeof Codemirror>(null);

    //------------------------------------------------------------------------------------------------------------------
    // Observables
    //------------------------------------------------------------------------------------------------------------------

    const duration = useObservable(requestMan.requestDuration$);
    const response = useObservable(requestMan.response$);
    const responseLoading = useObservable(requestMan.responseLoading$);

    //------------------------------------------------------------------------------------------------------------------
    // Computed
    //------------------------------------------------------------------------------------------------------------------

    const byteSize = computed(() =>
    {
        return (new TextEncoder().encode(JSON.stringify(response.value))).length / 1000;
    });

    const cmExtensions = computed(() =>
    {
        if(bsTheme.value === 'dark')
        {
            return [
                ...baseCMExtensions,
                oneDark,
            ];
        }

        return baseCMExtensions;
    });

    const durationVariant = computed(() =>
    {
        if(duration.value >= 1000)
        {
            return 'danger';
        }
        else if(duration.value >= 250)
        {
            return 'warning';
        }
        else
        {
            return 'success';
        }
    });

    const formattedPayload = computed(() =>
    {
        return requestMan.format(JSON.stringify(response.value.payload));
    });

    const formattedResponse = computed(() =>
    {
        return requestMan.format(JSON.stringify(response.value));
    });

    const messages = computed(() =>
    {
        return response.value?.messages;
    });

    const hasMessages = computed(() =>
    {
        return !!messages.value?.length;
    });

    const errorMessagesCount = computed(() =>
    {
        return messages.value?.filter((msg) => msg.severity === 'error').length ?? 0;
    });

    const warningMessagesCount = computed(() =>
    {
        return messages.value?.filter((msg) => msg.severity === 'warning').length ?? 0;
    });

    const infoMessagesCount = computed(() =>
    {
        return messages.value?.filter((msg) => msg.severity === 'info').length ?? 0;
    });

    const debugMessagesCount = computed(() =>
    {
        return messages.value?.filter((msg) => msg.severity === 'debug').length ?? 0;
    });

    //------------------------------------------------------------------------------------------------------------------
    // Methods
    //------------------------------------------------------------------------------------------------------------------

    function copyResponse() : void
    {
        const text = tabIndex.value === 2 ? formattedResponse.value : formattedPayload.value;
        clipboardMan.write(text);
    }

    // function cmRefresh() : void
    // {
    //     requestAnimationFrame(() =>
    //     {
    //         payloadCM.value?.refresh();
    //         responseCM.value?.refresh();
    //     });
    // }

    function getMessageAlertVariant(severity : 'error' | 'warning' | 'info' | 'debug') : string
    {
        switch (severity)
        {
            case 'error':
                return 'danger';
            case 'warning':
                return 'warning';
            case 'info':
                return 'info';
            case 'debug':
                return 'dark';
        }
    }

    function getMessageAlertIcon(severity : 'error' | 'warning' | 'info' | 'debug') : string
    {
        switch (severity)
        {
            case 'error':
                return 'exclamation-circle';
            case 'warning':
                return 'exclamation-triangle';
            case 'info':
                return 'info-circle';
            case 'debug':
                return 'bug';
        }
    }

    //------------------------------------------------------------------------------------------------------------------
    // Watch
    //------------------------------------------------------------------------------------------------------------------

    // watch(tabIndex, () => cmRefresh());

</script>

<!--------------------------------------------------------------------------------------------------------------------->
